<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { request } from '@/lib/request';
import { useMetaStore } from '@/stores/meta';
import type { dashboardItem } from '@/types/dashboard';
import { storeToRefs } from 'pinia';
import { computed, inject, onMounted, ref } from 'vue';
import { useI18n } from 'vue-i18n';
import FavoriteStar from '@/components/general/FavoriteStar.vue';
import { useBaseStore } from '@/stores/base';
import { notificationStatus } from '@/enums/enums';

const { t } = useI18n();
const $t = t; 

const metaStore = useMetaStore();
const baseStore = useBaseStore();
const favorites = ref<dashboardItem[]>([]);
const { hashcode, paneType } = storeToRefs(metaStore);
const { message, status } = storeToRefs(baseStore);

let configuration = inject<any>('configuration');

const props = defineProps<{
    size?: string
}>();

onMounted(async ()=>{
    const response = await request('GET', configuration.apiServer+`/api/account/favorite`, undefined, 'application/json', false, true);
    if(response && response.success){
        favorites.value = response.favorites;
    }else{
        console.error("Couldn't load favorites");
    }
});

const isFavorite = computed(()=>{
    const result = favorites.value.find((items:dashboardItem)=>items.hash_pane===hashcode.value);
    return result!==undefined && result!==null;
});

const handleFavorite = async ()=>{
    const method = isFavorite.value?'DELETE':'POST';
    const response = await request(method, configuration.apiServer+`/api/${paneType.value}/favorite/${hashcode.value}`, undefined, 'application/json', false, true);
    if(response && response.success){
        favorites.value = response.favorites;
        message.value = "";
        message.value = method==='POST'?$t('dashboardPage.favorites.add.message'):$t('dashboardPage.favorites.delete.message');
    }else{
        console.error("Couldn't be added / deleted to favorites");
        message.value = "";
        status.value = notificationStatus.DANGER;
        message.value = $t('general.errors.unexpected');
    }
}

</script>
<template>
    <FavoriteStar :isFavorite="isFavorite" :size="size" @click="handleFavorite"/>
</template>